::robot_model_cache <- {
    [TF_PLAYERCLASS_SCOUT] = {model = "models/player/fracture/bot_scout.mdl", viewmodel = "models/mvm/weapons/c_models/c_scout_bot_arms.mdl"},
    [TF_PLAYERCLASS_SOLDIER] = {model = "models/player/fracture/bot_soldier.mdl", viewmodel = "models/mvm/weapons/c_models/c_soldier_bot_arms.mdl"},
    [TF_PLAYERCLASS_PYRO] = {model = "models/player/fracture/bot_pyro.mdl", viewmodel = "models/mvm/weapons/c_models/c_pyro_bot_arms.mdl"},
    [TF_PLAYERCLASS_DEMOMAN] = {model = "models/player/fracture/bot_demo.mdl", viewmodel = "models/mvm/weapons/c_models/c_demo_bot_arms.mdl"},
    [TF_PLAYERCLASS_HEAVY] = {model = "models/player/fracture/bot_heavy.mdl", viewmodel = "models/mvm/weapons/c_models/c_heavy_bot_arms.mdl"},
    [TF_PLAYERCLASS_ENGINEER] = {model = "models/player/fracture/bot_engineer.mdl", viewmodel = "models/mvm/weapons/c_models/c_engineer_bot_arms.mdl"},
    [TF_PLAYERCLASS_MEDIC] = {model = "models/player/fracture/bot_medic.mdl", viewmodel = "models/mvm/weapons/c_models/c_medic_bot_arms.mdl"},
    [TF_PLAYERCLASS_SNIPER] = {model = "models/player/fracture/bot_sniper.mdl", viewmodel = "models/mvm/weapons/c_models/c_sniper_bot_arms.mdl"},
    [TF_PLAYERCLASS_SPY] = {model = "models/player/fracture/bot_spy.mdl", viewmodel = "models/mvm/weapons/c_models/c_spy_bot_arms.mdl"}
}

foreach (_, value in robot_model_cache)
{
    PrecacheModel(value.model)
    PrecacheModel(value.viewmodel)
}

::robot_spy_arms_cache <- [
    "models/mvm/weapons/v_models/v_pda_spy_bot.mdl"
    "models/mvm/weapons/v_models/v_ttg_watch_spy_bot.mdl"
    "models/mvm/weapons/v_models/v_watch_leather_spy_bot.mdl"
    "models/mvm/weapons/v_models/v_watch_pocket_spy_bot.mdl"
    "models/mvm/weapons/v_models/v_watch_spy_bot.mdl"
    "models/mvm/workshop_partner/weapons/v_models/v_hm_watch/v_hm_watch_bot.mdl"
]

foreach (_, value in robot_spy_arms_cache)
{
    PrecacheModel(value)
}

::robot_table <- [
    [ 0, "scout"],
    [ 1, "scout"],
    [ 3, "soldier"],
    [ 7, "pyro"],
    [ 4, "demo"],
    [ 6, "heavy"],
    [ 9, "engineer"],
    [ 5, "medic"],
    [ 2, "sniper"],
    [ 8, "spy"]
]

::human_table <- [
    [ 0, "scout", 125 ],
    [ 1, "scout", 125 ],
    [ 3, "soldier", 200 ],
    [ 7, "pyro", 175 ],
    [ 4, "demo", 175 ],
    [ 6, "heavy", 300 ],
    [ 9, "engineer", 150 ],
    [ 5, "medic", 150 ],
    [ 2, "sniper", 125 ],
    [ 8, "spy", 125 ]
]

::ModelSpawn <- function(params)
{
    if (!("userid" in params))
    return
    local player = GetPlayerFromUserID(params.userid)
    local player_class = player.GetPlayerClass()
    if (player.GetTeam() == TF_TEAM_BLUE)
    {
        if (player_class in robot_table)
        foreach (robotclass in robot_table)
        {
            local index = player.GetPlayerClass()
            if(index == robotclass[0])
            {
                player.SetCustomModelWithClassAnimations("models/player/fracture/bot_"+robotclass[1]+".mdl")
                local viewmodel = NetProps.GetPropEntity(player, "m_hViewModel")
                NetProps.SetPropInt(viewmodel, "m_nModelIndex", GetModelIndex("models/mvm/weapons/c_models/c_"+robotclass[1]+"_bot_arms.mdl"))
            }
        }
    }
    if (player.GetTeam() == TF_TEAM_RED)
    {
        if (player_class in human_table)
        foreach (humanclass in human_table)
        {
            local index = player.GetPlayerClass()
            if(index == humanclass[0])
            {
                player.SetCustomModelWithClassAnimations("models/player/"+humanclass[1]+".mdl")
                local viewmodel = NetProps.GetPropEntity(player, "m_hViewModel")
                NetProps.SetPropInt(viewmodel, "m_nModelIndex", GetModelIndex("models/weapons/c_models/c_"+humanclass[1]+"_arms.mdl"))
            }
        }
    }
}