::impactsound <- [
    "MVM.ImpactArrow", //0
    "MVM.ImpactBatBaseball", //1
    "MVM.ImpactBladeHit", //2
    "MVM.ImpactBladeSlice", //3
    "MVM.ImpactBottle", //4
    "MVM.ImpactBottleBroken", //5
    "MVM.ImpactCrowbar", //6
    "MVM.ImpactFistsOfSteel", //7
    "MVM.ImpactFryingPan", //8
    "MVM.ImpactSpyKnife", //9
    "MVM.ImpactBullet", //10
    "Weapon_PickAxe.HitFlesh", //11
    "MVM.ImpactSoft", //12
    "MVM.ImpactHard", //13
    "MVM.ImpactScrape" //14
]

::standardsoundmelee <- [
    ["Weapon_HolyMackerel.HitFlesh"],
    ["Weapon_FireAxe.HitFlesh"],
    ["Weapon_BaseballBat.HitFlesh"],
    ["Weapon_Bat.HitFlesh"],
    ["Weapon_Bottle.HitFlesh"],
    ["Weapon_Bottle.IntactHitFlesh"],
    ["Weapon_Bottle.BrokenHitFlesh"],
    ["Weapon_Machete.HitFlesh"],
    ["Weapon_Fist.HitFlesh"],
    ["Weapon_MetalGloves.HitFlesh"],
    ["Weapon_BoxingGloves.HitFlesh"],
    ["Weapon_FireAxe.HitFlesh"],
    ["Weapon_UberSaw.HitFlesh"],
    ["Weapon_BoneSaw.HitFlesh"],
    ["Weapon_Club.HitFlesh"],
    ["Weapon_Crowbar.HitFlesh"],
    ["Weapon_Knife.HitFlesh"],
    ["Weapon_Pipe.HitFlesh"],
    ["Weapon_Shovel.HitFlesh"],
    ["Weapon_Wrench.HitFlesh"],
    ["Weapon_PickAxe.HitFlesh"],
    ["DemoCharge.HitFleshRange"],
    ["DemoCharge.HitFlesh"],
    ["Weapon_Sword.HitFlesh"],
    ["FryingPan.HitFlesh"],
    ["Weapon_Katana.HitFlesh"],
    ["Weapon_Assassin_Knife.HitFlesh"],
    ["BallBuster.HitFlesh"],
    //["Weapon_3rd_degree.HitFlesh"],
    //["Weapon_mittens.HitFlesh"],
    //["Weapon_BatSaber.HitFlesh"],
]

::meleewepsstan <- [
    ["tf_weapon_bat"],
    ["tf_weapon_bat_fish"],
    ["tf_weapon_bat_wood"],
    ["tf_weapon_bonesaw"],
    //["tf_weapon_bottle"],
    //["tf_weapon_breakable_sign"],
    ["tf_weapon_club"],
    ["tf_weapon_fireaxe"],
    //["tf_weapon_fists"],
    //["tf_weapon_katana"],
    //["tf_weapon_knife"],
    ["tf_weapon_robot_arm"],
    ["tf_weapon_shovel"],
    ["tf_weapon_slap"],
    //["tf_weapon_sword"],
    //[],
]

function StopImpact(player)
{
    local index = player.GetPlayerClass()
    foreach (baseimpact in standardsoundmelee)
    {
        if (index == baseimpact[0])
        {
            StopSoundOn(baseimpact[0], player)
        }
    }
}

function MeleeWepsStandard(player)
{
    local index = player.GetPlayerClass()
    foreach (normwep in meleewepsstan)
    {
        if (index == normwep[0])
        {
            params.weapon.GetClassname(normwep[0], player)
        }
    }
}

::PlayerImpact <- function(params)
{
    local player = params.const_entity
    if (player == null && params.attacker != null && params.inflictor != null)
        return;

    if (params.const_entity.GetClassname() != "player")
        return;

    if (!params.inflictor.IsPlayer())
        return;

    local index = player.GetPlayerClass()
    if(params.attacker && params.attacker.IsPlayer() == false)
    {
        EmitAmbientSoundOn(impactsound[12], 0.2, 30, 100, player)
    }
    else if(params.weapon)
    {
        if (params.damage_custom == 27)
        {
            EmitAmbientSoundOn(impactsound[11], 1, 95, 100, player)
        }
        else if (params.weapon.GetClassname() == "worldspawn" || params.weapon.GetClassname() == "player")
        {
            EmitAmbientSoundOn(impactsound[13], 1, 95, 100, player)
        }
        else if ((params.weapon.GetClassname() !=  meleewepsstan[0]) && (params.weapon.GetClassname() == ("tf_weapon_compound_bow" || params.weapon.GetClassname() == "tf_weapon_crossbow")))
        {
            EmitAmbientSoundOn(impactsound[0], 1, 95, 100, player)
        }
        else if ((params.weapon.GetClassname() != meleewepsstan[0]) && (params.weapon.GetWeaponIndex() == (132 || 172 || 327 || 404 || 452 || 482 || 1082)))
        {
            EmitAmbientSoundOn(impactsound[RandomInt(2, 3)], 1, 95, 100, player)
        }
        else if (params.weapon.GetClassname() != meleewepsstan[0] && params.weapon.GetClassname() == "tf_weapon_bottle")
        {
            if (GetPropBool(params.weapon, "m_bBroken"))
                EmitAmbientSoundOn(impactsound[5], 1, 95, 100, player)
            else
                EmitAmbientSoundOn(impactsound[4], 1, 95, 100, player)

        }
        else if (params.weapon.GetClassname() != meleewepsstan[0] && (NetProps.GetPropInt(params.weapon,"m_iWorldModelIndex") == GetModelIndex("models/weapons/c_models/c_fists_of_steel/c_fists_of_steel.mdl")) || (NetProps.GetPropInt(params.weapon,"m_iWorldModelIndex") == GetModelIndex("models/workshop/weapons/c_models/c_fists_of_steel/c_fists_of_steel.mdl")))
        {
            EmitAmbientSoundOn(impactsound[7], 1, 95, 100, player)
        }
        else if (params.weapon.GetClassname() != meleewepsstan[0] && (NetProps.GetPropInt(params.weapon,"m_iWorldModelIndex") == GetModelIndex("models/weapons/c_models/c_fying_pan/c_fying_pan.mdl")))
        {
            EmitAmbientSoundOn(impactsound[8], 1, 95, 100, player)
        }
        else if (params.weapon.GetClassname() != meleewepsstan[0] && params.weapon.GetClassname() == "tf_weapon_knife")
        {
            EmitAmbientSoundOn(impactsound[9], 1, 95, 100, player)
        }
        else if (params.weapon.GetClassname() == meleewepsstan[0])
        {
            EmitAmbientSoundOn(impactsound[6], 1, 95, 100, player)
        }
        else
        {
            EmitAmbientSoundOn(impactsound[10], 1, 95, 100, player)
        }
    }
    else
    {
        EmitAmbientSoundOn(impactsound[12], 0.2, 30, 100, player)
    }
}