::CTFPlayer.TestPlayerGiveWeaponAndSave <- function(weapon, trigger) {
	if ( IsPlayerABot(this) ) return;
	if ( this.GetWeapon(weapon) ) return;
	
	local wep = this.GiveWeapon(weapon, null, Defaults|FixClassAnims)
	
//	if ( wep ) { }		// if weapon
//	else { this.CreateCustomWearable(weapon) }	// if cosmetic
	
	local parent = trigger.GetMoveParent()
	DispatchParticleEffect("pyrovision_blood",parent.GetOrigin(),Vector(0,0,0))
	
	EntFireByHandle(parent,"FireUser1",null,0.0,null,null)
	EntFireByHandle(parent,"Kill",null,0.01,null,null)
}
::CTFBot.TestPlayerGiveWeaponAndSave <- CTFPlayer.TestPlayerGiveWeaponAndSave

::CreateWeaponPickup <- function(itemID,parent)
{
	local wearable = Entities.CreateByClassname("tf_wearable")
	
	wearable.SetAbsAngles(QAngle(0,0,0))
	wearable.SetAbsOrigin(parent.GetOrigin())
	SetPropInt(wearable, "m_fEffects", 32)
	wearable.SetSolidFlags(4);
	wearable.SetCollisionGroup(11);
	SetPropInt(wearable, "m_AttributeManager.m_Item.m_bInitialized", 1)
	
	if ( itemID > 65535 )
		SetPropInt(wearable, "m_AttributeManager.m_Item.m_iItemDefinitionIndex", 65535)
	else
		SetPropInt(wearable, "m_AttributeManager.m_Item.m_iItemDefinitionIndex", itemID)
	
	Entities.DispatchSpawn(wearable)
	
	return wearable
}

::Wep_BBox_Center <- function(BBox,point,wep) {
	local x = (point.GetAbsAngles().Forward() * (BBox.x/-2))
	local y = (point.GetAbsAngles().Left() * (BBox.y/-2))
	local test = BBox.x > BBox.y ? x : y
	
	if ( BBox.x > BBox.y ) {
		if ( BBox.z > 23 )	//if taller than 23 units
			return BBox.x > 63 ? test : Vector(0,0,0)
		else
			return Vector(0,0,0)
	}
	else {
		if ( BBox.z > 23 ) // if taller than 23 units
			return BBox.y > 63 ? test : Vector(0,0,0)
		else
			return Vector(0,0,0)
	}
	
}
::GTFW_DropWeapon <- function(wep, spawnpoint=null, despawnTimer=30, teamRestriction=0, skinNumber=-1, randomDegreeSpawn=0.0, offsetModelPosition=Vector(0,0,0), useAngleTilt=true) {
	
	if ( !wep ) return;

	local wepScope;
	
	if ( type(wep) == "instance" 
	  && wep.IsValid() ) {
		wepScope = wep.GetOwner().GetWeaponTable(wep);
		spawnpoint = wep.GetOwner().GetCenter();
		skinNumber = skinNumber == -1 ? ( wep.GetTeam() == 3 ? 1 : 0 ) : 0;
	}
	else { 
		wepScope = GetWeaponTableNoPlayer(wep);
		spawnpoint = !spawnpoint ? Vector(0,0,0) : spawnpoint;
		skinNumber = 0;
	}

	if ( !wepScope ) return
	
	local itemID = wepScope.itemID;
	
	local modelPath;
	if ( "worldModelProp" in wepScope
	  && wepScope.worldModelProp && wepScope.worldModelProp.IsValid() ) {
		modelPath = wepScope.worldModelProp.GetModelName()
	}
	else modelPath = GetItemModelName(itemID);
	
	local Rune_Name = UniqueString()
	local point = SpawnEntityFromTable("item_powerup_rune", {
		targetname = Rune_Name,
		angles = QAngle(0,0,0),
		AutoMaterialize = 0,
		powerup_model = "models/empty.mdl",
		teamnum = 4,
		origin = spawnpoint,
	})
	
	local q = randomDegreeSpawn;
	point.ApplyAbsVelocityImpulse(Vector(RandomInt(-q,q),RandomInt(-q,q),RandomInt(-q,q)))
	
	local prop = CreateWeaponPickup(itemID,point);
	
	local weapon = SpawnEntityFromTable("prop_dynamic", {
		model = modelPath,
		origin = point.GetOrigin(),
		angles = QAngle(0,0,0),
		DisableBoneFollowers = true,
		disableshadows	=	true,
		skin = skinNumber,
	})
	local BBox = Vector(fabs(weapon.GetBoundingMaxs().x),fabs(weapon.GetBoundingMaxs().y),fabs(weapon.GetBoundingMaxs().z)) + Vector(fabs(weapon.GetBoundingMins().x),fabs(weapon.GetBoundingMins().y),fabs(weapon.GetBoundingMins().z))

	if ( useAngleTilt )
		weapon.SetLocalAngles(QAngle( BBox.z < 90 ? ( BBox.z > BBox.x ? ( BBox.z > BBox.y ? ( BBox.x > BBox.y ? 15 : 0 ) : 0 ) : 0 ) : 0 , 0 , BBox.z < 90 ? ( BBox.z > BBox.x ? ( BBox.z > BBox.y ? ( BBox.x > BBox.y ? 0 : 15 ) : 0 ) : 0 ) : 0 ) )
	
	weapon.SetOrigin(point.GetOrigin()+(point.GetAbsAngles().Up()*(BBox.z > 90 ? 0 - BBox.z / 10 : 48 ))+Wep_BBox_Center(BBox,point,weapon)+offsetModelPosition)
	
	prop.Kill()
	
	local trigger = SpawnEntityFromTable("trigger_multiple", {
		mins = Vector(-24,-24,0),
		maxs = Vector(24,24,32),
		origin = point.GetOrigin()+(point.GetAbsAngles().Up()*48),
		spawnflags = 1,
		StartDisabled = 1,
		
		filtername = teamRestriction == 0 ? "" : ( teamRestriction == 3 ? "filter_blu" : "filter_red" )
		
		"OnUser1#1"		: Rune_Name+",Kill,,0,1",
	})
	
	EntityOutputs.AddOutput(trigger, "OnStartTouch", "!activator", "RunScriptCode", "self.TestPlayerGiveWeaponAndSave("+itemID+", caller)", 0.0, -1);
	trigger.SetSolid(Constants.ESolidType.SOLID_BBOX);
	
	local particle_live = SpawnEntityFromTable("trigger_particle", 
	{
		particle_name	= "burningplayer_rainbow_stars04",
		spawnflags		= 64,
		attachment_type	= 1,
		origin			= Entities.First().GetBoundingMaxs(),
		mins		= Vector(0,0,0),
		maxs		= Vector(0,0,0),
	})
	local particle_fading = SpawnEntityFromTable("trigger_particle", 
	{
		particle_name	= "burningplayer_rainbow_glow",
		spawnflags		= 64,
		attachment_type	= 1,
		origin			= Entities.First().GetBoundingMaxs(),
		mins		= Vector(0,0,0),
		maxs		= Vector(0,0,0),
	})

	EntFireByHandle(weapon,"SetParent","!activator",0.0,trigger,trigger)
	EntFireByHandle(trigger,"SetParent","!activator",0.0,point,point)
	EntFireByHandle(particle_live,"SetParent","!activator",0.0,point,point)
	EntFireByHandle(particle_fading,"SetParent","!activator",0.0,point,point)
	
	EntFireByHandle(particle_live,"StartTouch",null,0.0,weapon,weapon)
	
	::anglecap <- function(angle) {
		return angle >= 360 ? 0 : angle
	}
/*	::bounce <- function(ground_origin,weapon) {
		local bounce_flag = true
		local bounce_z = 0
		for ( local i = 0; i < 28; i++ ) {
			local origin = weapon.GetOrigin()
			if ( bounce_flag )
				bounce_flag = bounce_z >= 14 ? false : true
			else
				bounce_flag = bounce_z <= 0 ? true : false
			
			bounce_z = bounce_z - ( bounce_flag ? -0.2 : 0.1 )
			
			origin = format("%f %f %f",origin.x,origin.y,ground_origin+bounce_z.tofloat())
			trigger.__KeyValueFromString("origin", origin)
			printl(origin)
		}
	}*/
	
	weapon.ValidateScriptScope()
	local scope = weapon.GetScriptScope()
	local a = 0
	
	local origin = 0
	local bounce_timer = 0
	local bounce_flag = true
	local bounce_z = 0
	
	local OnGround = false
	
	local SpawnTime = Time()
	local HasFlashed = false
	local despawnTimerFlashStart = despawnTimer - 5
	
	scope["Rotation"] <- function()
	{
		if ( HasFlashed == false && SpawnTime + despawnTimerFlashStart < Time() ) {
			HasFlashed = true;
			weapon.__KeyValueFromInt("renderfx", 10);
			weapon.__KeyValueFromInt("rendermode", 2);
			weapon.__KeyValueFromInt("renderamt", 172);
			EntFireByHandle(particle_fading,"StartTouch",null,0.0,weapon,weapon);
		}
		else if ( HasFlashed && SpawnTime + despawnTimer < Time() ) {
			if ( point ) point.Kill();
			return 99
		}
		
		a = trigger.GetAbsAngles()
		
		if ( OnGround == false && GetPropEntity(point,"m_hGroundEntity") ) {
			EntFireByHandle(trigger,"Enable",null,0.0,null,null)
			OnGround = true
		}
		
		if ( OnGround && a.y == 0 || a.y == 120 || a.y == 240)
			DispatchParticleEffect("ping_circle",point.GetOrigin()+(point.GetAbsAngles().Up()),Vector(0,0,0))
		
		if ( OnGround ) {
			/*
			if ( bounce_timer >= 1 ) {
				bounce_timer = 0
				
				origin = weapon.GetOrigin()
				if ( bounce_flag )
					bounce_flag = bounce_z >= 3 ? false : true
				else
					bounce_flag = bounce_z <= 0 ? true : false
				
				bounce_z = bounce_z - ( bounce_flag ? -0.05 : 0.05 )
				
				origin = format("%f %f %f",origin.x,origin.y,point.GetOrigin().z+(point.GetAbsAngles().Up().z*48)+bounce_z.tofloat())
				trigger.__KeyValueFromString("origin", origin)
			}
			else bounce_timer += 1
			*/
			
			a = format("%d %d %d",a.x,anglecap(a.y+2),a.z)
			trigger.__KeyValueFromString("angles", a)
		}
		
		return 0.0
	}
	AddThinkToEnt(weapon, "Rotation")
}


::DropWeaponGlow <- function(weapon) {
	local particle_live = SpawnEntityFromTable("trigger_particle", 
	{
		particle_name	= "burningplayer_rainbow_stars_base",
		spawnflags		= 64,
		attachment_type	= 1,
		origin			= Entities.First().GetBoundingMaxs(),
		mins		= Vector(0,0,0),
		maxs		= Vector(0,0,0),
	})
	EntFireByHandle(particle_live,"StartTouch",null,0.0,weapon,weapon)
	particle_live.Kill()
}
::DropWeaponGlow_Stop <- function(weapon) {
	EntFireByHandle(weapon, "DispatchEffect", "ParticleEffectStop", 0.0, weapon, weapon)
}